#pragma rtGlobals=3		// Use modern global access method and strict wave access.



//
////  statistics of background ROIs around a particle
//function  calculate_BG( spred, rad, xC, yC, bgDist, backgW, imageW )
//	variable spred, rad, xC, yC, bgDist
//	wave backgW, imageW 
//	//
//	variable centerPos, xStart, xEnd, yStart, yEnd
//	variable bckgCounter = 0, zz, V_flag
//	//
//	for( zz = 0 ; zz < spred ; zz +=1 )
//		centerPos = zz * rad * 2
//		// Middle Top ROI
//		xStart = xC - rad
//		xEnd = xC + rad
//		yStart = yC - rad + bgDist + centerPos + rad
//		yEnd = yC + rad + bgDist + centerPos + rad
//		V_flag = 0
//		ImageStats/M =1 /G={ xStart, xEnd, yStart, yEnd } imageW
//		if( V_flag >= 0 )
//			insertPoints/m=0 bckgCounter , 1 , backgW
//			backgW[ bckgCounter ] = V_avg
//			bckgCounter += 1
//		endif
//		// Middle Backgound ROI
//		xStart = xC - rad
//		xEnd = xC + rad
//		yStart = yC - rad - bgDist - centerPos - rad
//		yEnd = yC + rad - bgDist - centerPos - rad
//		V_flag = 0
//		ImageStats /G={ xStart, xEnd, yStart, yEnd } imageW
//		if( V_flag >=  0 )
//			insertPoints/m=0 bckgCounter , 1 , backgW
//			backgW[ bckgCounter ] = V_avg
//			bckgCounter += 1
//		endif
//		// middle right ROI
//		xStart = xC - rad + bgDist + centerPos + rad
//		xEnd = xC + rad + bgDist + centerPos + rad
//		yStart = yC - rad
//		yEnd = yC + rad
//		V_flag = 0
//		ImageStats/M =1 /G={ xStart, xEnd, yStart, yEnd } imageW
//		if( V_flag >=  0 )
//			insertPoints/m=0 bckgCounter , 1 , backgW
//			ImageStats /G={ xStart, xEnd, yStart, yEnd } imageW
//			backgW[ bckgCounter ] = V_avg
//			bckgCounter += 1
//		endif
//		// middle left ROI
//		xStart = xC - rad - bgDist - centerPos - rad
//		xEnd =  xC + rad - bgDist - centerPos - rad
//		yStart = yC - rad
//		yEnd = yC + rad
//		V_flag = 0
//		ImageStats/M =1 /G={ xStart, xEnd, yStart, yEnd } imageW
//		if( V_flag >=  0 )
//			insertPoints/m=0 bckgCounter , 1 , backgW
//			ImageStats /G={ xStart, xEnd, yStart, yEnd } imageW
//			backgW[ bckgCounter ] = V_avg
//			bckgCounter += 1
//		endif
//		// Bottom left ROI
//		xStart = xC - rad - bgDist  - centerPos - rad
//		xEnd = xC + rad - bgDist - centerPos - rad
//		yStart = yC - rad - bgDist - centerPos - rad
//		yEnd = yC + rad - bgDist - centerPos - rad
//		V_flag = 0
//		ImageStats/M =1 /G={ xStart, xEnd, yStart, yEnd } imageW
//		if( V_flag >=  0 )
//			insertPoints/m=0 bckgCounter , 1 , backgW
//			ImageStats /G={ xStart, xEnd, yStart, yEnd } imageW
//			backgW[ bckgCounter ] = V_avg
//			bckgCounter += 1
//		endif
//		// top left ROI
//		xStart = xC  - rad - bgDist  - centerPos  - rad
//		xEnd =  xC  + rad - bgDist - centerPos - rad
//		yStart = yC - rad + bgDist + centerPos + rad
//		yEnd = yC + rad + bgDist + centerPos + rad
//		V_flag = 0
//		ImageStats/M = 1 /G={ xStart, xEnd, yStart, yEnd } imageW
//		if( V_flag >=  0 )
//			insertPoints/m=0 bckgCounter , 1 , backgW
//			ImageStats /G={ xStart, xEnd, yStart, yEnd } imageW
//			backgW[ bckgCounter ] = V_avg
//			bckgCounter += 1
//		endif
//		// bottom right ROI
//		xStart = xC - rad + bgDist  + centerPos + rad
//		xEnd = xC + rad + bgDist +centerPos + rad
//		yStart = yC - rad - bgDist - centerPos - rad
//		yEnd = yC + rad - bgDist - centerPos - rad
//		V_flag = 0
//		ImageStats/M =1 /G={ xStart, xEnd, yStart, yEnd } imageW
//		if( V_flag >=  0 )
//			insertPoints/m=0 bckgCounter , 1 , backgW
//			ImageStats /G={ xStart, xEnd, yStart, yEnd } imageW
//			backgW[ bckgCounter ] = V_avg
//			bckgCounter += 1
//		endif
//		// Top right ROI
//		xStart = xC  - rad + bgDist  + centerPos + rad
//		xEnd =  xC + rad + bgDist + centerPos + rad
//		yStart = yC - rad + bgDist  + centerPos + rad
//		yEnd = yC + rad + bgDist + centerPos + rad
//		V_flag = 0
//		ImageStats/M = 1 /G={ xStart, xEnd, yStart, yEnd } imageW
//		if( V_flag >=  0 )
//			insertPoints/m=0 bckgCounter , 1 , backgW
//			ImageStats /G={ xStart, xEnd, yStart, yEnd } imageW
//			backgW[ bckgCounter ] = V_avg
//			bckgCounter += 1
//		endif
//	endFor  // end of bckg ROI drawing
//	//		
//end
////

//// **********   global background intensity in single frame function ***********
//Function globalBckg_TA_MT( coordinatesLocal , proteinImage , bckgMask  )
//	wave coordinatesLocal    // coordinates of particles
//	wave proteinImage		// frame for intensity extraction
//	wave bckgMask
//	variable leftMembraneCircle, topMembraneCircle, rightMembraneCircle, bottomMembraneCircle  // corners coords of the circle
//	variable tu										// counter
//	//*****
//	doWindow/k imageBckgrWindow
//	newImage/hide = 1 /n = imageBckgrWindow proteinImage
//	// drawing circles around particles
//	for( tu = 0 ; tu < dimSIze( coordinatesGlobal , 0 ) ; tu += 1 )
//		SetDrawLayer/W=imageBckgrWindow progFront
//		SetDrawEnv/w=imageBckgrWindow linefgc= (3,52428,1),fillpat= 0,xcoord=top,ycoord=left,save
//		// corner coords of the circle around particle tu
//		leftMembraneCircle =( coordinatesLocal[ tu ][ 1 ] - coordinatesLocal[ tu ][ 4 ] )
//		topMembraneCircle =( coordinatesLocal[ tu ][ 2 ] - coordinatesLocal[ tu ][ 4 ] )
//		rightMembraneCircle =( coordinatesLocal[ tu ][ 1 ] + coordinatesLocal[ tu ][ 4 ] )
//		bottomMembraneCircle =( coordinatesLocal[ tu ][ 2 ] + coordinatesLocal[ tu ][ 4 ] )
//		// drawing circle around a particle tu
//		DrawOval/W=imageBckgrWindow leftMembraneCircle, topMembraneCircle, rightMembraneCircle, bottomMembraneCircle
//	endfor
//	doUpdate
//	// bckg mask
//	killWaves/z imageROI, M_ROIMask
//	make/o/n= (0,0) M_ROIMask = 0
//	ImageGenerateROIMask/w=imageBckgrWindow/e=0/I=1 proteinImage		// generates mask from imageROI wave with values of interior = 1, exterior = 0
//	redimension/b/u/n=( dimSize(proteinImage,0), dimSize(proteinImage,1)) M_ROIMask
//	killWaves/z bckgMask
//	duplicate/o M_ROIMask , bckgMask
//	// releasing the memory occupyed by variables
//	killVariables/z leftMembraneCircle, topMembraneCircle, rightMembraneCircle, bottomMembraneCircle , tu
//	killWaves/z imageROI, M_ROIMask
//end

//
//// automatic paricle detection by intensity threshold variation
//function/d analPartVarThresh( image1, minArea, circularity , wOut )
//	wave image1
//	variable  minArea, circularity
//	string wOut
//	//
//	NVAR ballSizeThresh
//	//
//	duplicate/o image1, imLoc
//	wavestats/q imLoc
//	//
//	variable numIteration = 150
//	variable maxGray = V_max
//	variable coef1 = 1.3
//	//
//	duplicate/o imLoc, tempImage1
//	duplicate/o tempImage1, intImage
//	redimension/n=(dimSize(tempImage1,0)*dimSize(tempImage1,1)) intImage
//	//
//	//Make/N=512/O image_hist
//	//Histogram/C/B=1 tempImage1,image_hist
//	//CurveFit /NTHR=0 /Q / W = 2 /N gauss  image_hist
//	//wave W_coef
//	//minGray = W_coef[2] + w_coef[ 3 ] * 0.3
//	//
//	variable minGray = abs( estAvg_bootstrap( intImage ) + estSD_bootstrap( intImage ) * 0.5 ) //* coef1
//	//
//	if( minGray > maxGray )
//		minGray = V_avg
//	endif
//	//
//	variable stepSize = maxGray - minGray
//	stepSize /= numIteration
//	variable nPart = 0,aa
//	//
//	make/o /n = ( 0, 6 ) coords
//	//
//	print "Automatic thresholds: min "+num2str(minGray)+" max "+num2str(maxGray)+" step size "+num2str(stepSize)
//	//
//	for( aa = 0 ; aa < numIteration - 1  ; aa +=  1 )
//		// update threshold value
//		maxGray -= stepSize
//		// make a bianry image using threshod
//		ImageThreshold/I/T=( maxGray ) imLoc 
//		Wave M_imageThresh
//		// detect particles in the binary image
//		imageAnalyzeParticles /m=3 /Q /CIRC = { (circularity) , 1000} /EBPC /A=( minArea ) /E /MAXA=30stats M_imageThresh
//		wave M_moments, W_imageObjArea, W_circularity, M_Particle
//		//
//		fillColumns( coords, M_moments, W_imageObjArea, W_circularity, imLoc, nPart, 5 )
//		//
//		EraseParticle( imLoc, M_Particle )
//		//
//		if( maxGray - stepSize < minGray )
//			break
//		endif
//		//
//	endFor
//	//
//	duplicate/o coords, $wOut
//	killWaves/z  coords, imLoc, numPartDetect, tempImage1
//	killVariables/z numIteration, aa, indicator, bb, cc, distance,maxGray , stepSize,distThresh, dd
//	//
//	return minGray
//	//
//end

////
//function fillColumns( coords, M_moments, W_imageObjArea, W_circularity, imLoc,nPart, minDIst )
//	// list of detected particles
//	wave coords, M_moments, W_imageObjArea, W_circularity, imLoc
//	variable nPart,minDIst
//	//
//	variable aa
//	for( aa = 0 ; aa < dimSIze( M_moments, 0 ) ; aa += 1 )
//		// 
//		if( dimSize(coords,0) > 0 )
//			// estimae distance between particle aa from M_moments and all partilces in the list Coords.
//			make/o /n = ( dimSize(coords, 0)) distLocW
//			distLocW[ ] = sqrt( (coords[ p ][ 0 ] - M_moments[ aa ][ 0 ])^2 + (coords[ p ][ 1 ] - M_moments[ aa ][ 1 ])^2 )
//			wavestats/q distLocW
//			if( distLocW[V_minRowLoc] > minDIst )
//				//
//				insertPoints/m = 0 nPart, 1, coords
//				coords[ nPart ][ 0 ] = M_moments[ aa ][ 0 ] 	// x Coord
//				coords[ nPart ][ 1 ] = M_moments[ aa ][ 1 ] 	// y Coord
//				coords[ nPart ][ 2 ] = M_moments[ aa ][ 2 ] 	// x axis	- lenght of major axis
//				coords[ nPart ][ 3 ] = M_moments[ aa ][ 3 ] 	// y axis	- lenght of minor axis
//				coords[ nPart ][ 4 ] = W_imageObjArea[ aa ] 	// y axis
//				coords[ nPart ][ 5 ] = W_circularity[ aa ]		// y axis
//				//
//				nPart += 1
//				//
//			endif
//			//
//		else
//			//
//			insertPoints/m = 0 nPart, 1, coords
//			coords[ nPart ][ 0 ] = M_moments[ aa ][ 0 ] 	// x Coord
//			coords[ nPart ][ 1 ] = M_moments[ aa ][ 1 ] 	// y Coord
//			coords[ nPart ][ 2 ] = M_moments[ aa ][ 2 ] 	// x axis	- lenght of major axis
//			coords[ nPart ][ 3 ] = M_moments[ aa ][ 3 ] 	// y axis	- lenght of minor axis
//			coords[ nPart ][ 4 ] = W_imageObjArea[ aa ] 	// y axis
//			coords[ nPart ][ 5 ] = W_circularity[ aa ]		// y axis
//			//
//			nPart += 1
//			//
//		endif
//		//
//	endFor
//	//
//end
////

//
//Function EraseParticle( imLoc, M_Particle )
//	wave imLoc, M_Particle
//	//
//	multiThread imLoc = M_Particle[p][q]==16 ? 0 : imLoc[p][q]
//	//
//end
//
//function/d estAvg_bootstrap( wave1 )
//	wave wave1
//	//
//	variable aa = 0 , bb = 0, nBin = dimSIze( wave1,0 )
//	// resample the amplitudes
//	variable numPoints = 0
//	if( dimSize( wave1, 0 ) > 1000 )
//		numPoints = 1000
//	else
//		numPoints = 	dimSize( wave1, 0 )
//	endif
//	StatsResample /N=(numPoints) /ITER = ( numPoints ) /Q /WS = 2 wave1
//	wave M_WaveStatsSamples
//	make/o/n=(dimSize(M_WaveStatsSamples,0)) mean1 = M_WaveStatsSamples[3][p]
//	variable vOut = abs( mean( mean1 ) )
//	//
//	return vOut
//	//
//end
////
//function/d estSD_bootstrap( wave1 )
//	wave wave1
//	//
//	variable aa = 0 , bb = 0, nBin = dimSIze( wave1,0 )
//	// resample the amplitudes
//	variable numPoints = 0
//	if( dimSize( wave1, 0 ) > 1000 )
//		numPoints = 1000
//	else
//		numPoints = 	dimSize( wave1, 0 )
//	endif
//	StatsResample /N=(numPoints) /ITER = ( numPoints ) /Q /WS = 2 wave1
//	wave M_WaveStatsSamples
//	make/o/n=(dimSize(M_WaveStatsSamples,0)) mean1 = M_WaveStatsSamples[4][p]
//	variable vOut = abs( mean( mean1 ) )
//	//
//	return vOut
//	//
//end
////
//
//
//function detectPart_gauss_ta_mt( image,cropArea , channelIndicator )
//	wave image
//	variable cropArea, channelIndicator
//	//
//	variable count1 = 0, aa = 0, bb = 0, distance
//	variable xCoordInput, yCoordInput
//	make/o/n=(1,5) outW_pDetGauss
//	// make coordinates randomly for checking amplitude of Gaussian fitted to noise
//	make/o/n=(dimsize(image,0)*dimsize(image,1),2) randomPos = round ( abs( enoise( min( dimsize(image,0) - 1 , dimsize(image,1) - 1  )  ) ) )
//	make/o/n=0 testAmp
//	//
//	for( aa = 0 ; aa < dimsize( randomPos, 0 ) ; aa += round( cropArea * 2 )  )
//		make/o /n = 3 fittingErrorWave
//		make/d /o /n = 9 outputWave2
//		xCoordInput = randomPos[aa][0] + cropArea
//		yCoordInput = randomPos[aa][1] + cropArea
//		SParticle_TA_MT( image, xCoordInput , yCoordInput, outputWave2, cropArea, 1, fittingErrorWave , channelIndicator )
//		//
//		if( outputWave2[ 8 ] < 1 ) // fit succeded
//			insertpoints/m=0 count1 , 1, testAmp
//			testAmp[count1] = abs( outputWave2[ 1 ] ) // amp
//			count1 += 1
//		endif
//		//
//		if( count1 > 200 )
//			break
//		endif
//	endFor
//	// take bootstrap average and sd of test amplitudes
//	statsresample/ITER=100/n=(dimsize(testAmp,0)-2)/WS=1  testAmp
//	wave M_WaveStatsSamples
//	make/o/n=(dimsize(M_WaveStatsSamples,1)) meanW = M_WaveStatsSamples[3][p]
//	variable minAmp = mean( meanW )
//	print minAmp, ": minimal amplitude for Gaussian in particle detection"
//	//
//	count1 = 0
//	for( aa = 0 ; aa < dimsize( image, 0 ) ; aa += round( cropArea * 2 )  )
//		for( bb = 0 ; bb < dimsize( image, 1 ) ; bb +=  round( cropArea * 2 )  )
//			make/o /n = 3 fittingErrorWave
//			make/d /o /n = 9 outputWave2
//			xCoordInput = aa + cropArea
//			yCoordInput = bb + cropArea
//			SParticle_TA_MT( image, xCoordInput , yCoordInput, outputWave2, cropArea, 1, fittingErrorWave, channelIndicator )
//			//
//			if( outputWave2[ 8 ] < 1 ) // fit succeded
//				if( outputWave2[ 1 ] >  minAmp ) // check the amplitude of Gaussian fit
//					insertpoints/m=0 count1 , 1, outW_pDetGauss
//					outW_pDetGauss[count1][0] = outputWave2[ 3 ] // x centre
//					outW_pDetGauss[count1][1] = outputWave2[ 4 ] // y centre
//					outW_pDetGauss[count1][2] = outputWave2[ 5 ] // width
//					outW_pDetGauss[count1][3] = outputWave2[ 1 ] // amplitude
//					outW_pDetGauss[count1][4] = outputWave2[ 7 ] // baseline
//					count1 += 1
//				endif
//			endif
//			//
//		endFor
//	endFor
//	//
//	for( aa = round( cropArea  ) ; aa < dimsize( image, 0 ) ; aa += round( cropArea * 2 )  )
//		for( bb = round( cropArea  ) ; bb < dimsize( image, 1 ) ; bb +=  round( cropArea * 2 )  )
//			make/o /n = 3 fittingErrorWave
//			make/d /o /n = 9 outputWave2
//			xCoordInput = aa + cropArea
//			yCoordInput = bb + cropArea
//			SParticle_TA_MT( image, xCoordInput , yCoordInput, outputWave2, cropArea, 1, fittingErrorWave, channelIndicator )
//			//
//			if( outputWave2[ 8 ] < 1 ) // fit succeded
//				if( outputWave2[ 1 ] >  minAmp ) // check the amplitude of Gaussian fit
//					insertpoints/m=0 count1 , 1, outW_pDetGauss
//					outW_pDetGauss[count1][0] = outputWave2[ 3 ] // x centre
//					outW_pDetGauss[count1][1] = outputWave2[ 4 ] // y centre
//					outW_pDetGauss[count1][2] = outputWave2[ 5 ] // width
//					outW_pDetGauss[count1][3] = outputWave2[ 1 ] // amplitude
//					outW_pDetGauss[count1][4] = outputWave2[ 7 ] // baseline
//					count1 += 1
//				endif
//			endif
//			//
//		endFor
//	endFor
//	//
//	print dimsize(outW_pDetGauss,0) , ": number of putative paticles."
//	// erase overlapping particles
//	checkOverlapSpots( outW_pDetGauss, 2, round( cropArea * 3 ), cropArea )
//	// report number of detected particles
//	print dimsize(outW_pDetGauss,0) , ": number of verified paticles."
//	//
//end
//// decide wether two input putative fluorescent spots are better
//// fitted by single or dbl 2D Gaussian
//function/wave singleVsDbl_2DGauss( image, paramW, aa , bb, cropSize )	// if output var == 1 - single Gauss, 2 - dbl Gauss
//	wave image, paramW
//	variable aa , bb, cropSize
//	//
//	variable V_fitError = 0  			//  fit error
//	variable V_fitMaxIters = 100  	//  maximal number of iterations during fitting
//	variable V_fitOptions = 4		// fitting option
//	variable V_chisq = 0
//	make/o/n=3 chiWave = 0
//	//
//	make/o /d /n = 9 W_sigma = 0 	// error of gaussian fit wave
//	make/o /d /n = 9 W_coef			// parameters of gaussian fit wave
//	W_coef[ 0 ] = abs( paramW[ aa ][ 4 ] + paramW[ bb ][ 4 ] ) / 2	// baseline
//	W_coef[ 1 ] = paramW[ aa ][ 3 ]								// amp0
//	W_coef[ 2 ] = paramW[ aa ][ 0 ]								// x0
//	W_coef[ 3 ] = paramW[ aa ][ 1 ]								// y0
//	W_coef[ 4 ] = paramW[ aa ][ 2 ]								// width0
//	W_coef[ 5 ] = paramW[ bb ][ 3 ]								// amp1
//	W_coef[ 6 ] = paramW[ bb ][ 0 ]								// x1
//	W_coef[ 7 ] = paramW[ bb ][ 1 ]								// y1
//	W_coef[ 8 ] = paramW[ bb ][ 2 ]								// width1
//	// limits of ROI for fit
//	variable xStart = max( 0, min( paramW[ aa ][ 0 ] , paramW[ bb ][ 0 ] ) - cropSize )
//	variable xEnd = min( max( paramW[ aa ][ 0 ] , paramW[ bb ][ 0 ] ) + cropSize, dimsize( image, 0 ) - 1 )
//	variable yStart = max( 0, min( paramW[ aa ][ 1 ] , paramW[ bb ][ 1 ] ) - cropSize )
//	variable yEnd = min( max( paramW[ aa ][ 1 ] , paramW[ bb ][ 1 ] ) + cropSize, dimsize( image, 1 ) - 1 )
//	// do the dbl 2d gaussian fit
//	k0 = W_coef[ 0 ]; k1 = W_coef[ 1 ] ; k2= W_coef[ 2 ]
//	k3 = W_coef[ 3 ]; k4 = W_coef[ 4 ] ; k5 = W_coef[ 5 ]
//	k6 = W_coef[ 6 ]; k7 = W_coef[ 7 ] ; k8 = W_coef[ 8 ]
//	V_chisq = 0
//	FuncFitMD/H="111111111"/N /NTHR=0 /G /W =2 /Q dblGaus2dAllAtOnce W_coef  image[ xStart, xEnd ][ yStart, yEnd ]
//	if( V_fitError == 0 )   // if fitting was without problems
//		chiWave[ 0 ] = V_chisq
//	else
//		chiWave[ 0 ] = 100
//	endif
//	// fit single Gaussians to putative fluorescent spot aa
//	make/o /d /n = 5 W_coef = { paramW[ aa ][ 4 ], paramW[ aa ][ 3 ] , paramW[ aa ][ 0 ], paramW[ aa ][ 1 ], paramW[ aa ][ 2 ] }
//	make/o /d /n = 5 W_sigma = 0
//	//
//	xStart = max( 0, paramW[ aa ][ 0 ] - cropSize )
//	xEnd = min( paramW[ aa ][ 0 ] + cropSize, dimsize( image, 0 ) - 1 )
//	xStart = max( 0, paramW[ aa ][ 1 ] - cropSize )
//	xEnd = min( paramW[ aa ][ 1 ] + cropSize, dimsize( image, 1 ) - 1 )
//	//
//	k0 = W_coef[ 0 ]; k1 = W_coef[ 1 ] ; k2= W_coef[ 2 ]
//	k3 = W_coef[ 3 ]; k4 = W_coef[ 4 ]
//	// do the single 2D gaussian fit for florescent spot aa
//	V_fitError = 0  ; V_chisq = 0
//	FuncFitMD/H="11111"/N /NTHR=0 /G /W =2 /Q gaus2dAllAtOnce W_coef  image[ xStart, xEnd ][ yStart, yEnd ]
//	if( V_fitError == 0 )   // if fitting was without problems
//		chiWave[ 1 ] = V_chisq
//	else
//		chiWave[ 1 ] = 100
//	endif
//	// fit single Gaussians to putative fluorescent spot bb
//	make/o /d /n = 5 W_coef = { paramW[ bb ][ 4 ], paramW[ bb ][ 3 ] , paramW[ bb ][ 0 ], paramW[ bb ][ 1 ], paramW[ bb ][ 2 ] }
//	make/o /d /n = 5 W_sigma = 0
//	xStart = max( 0, paramW[ bb ][ 0 ] - cropSize )
//	xEnd = min( paramW[ bb ][ 0 ] + cropSize, dimsize( image, 0 ) - 1 )
//	xStart = max( 0, paramW[ bb ][ 1 ] - cropSize )
//	xEnd = min( paramW[ bb ][ 1 ] + cropSize, dimsize( image, 1 ) - 1 )
//	k0 = W_coef[ 0 ]; k1 = W_coef[ 1 ] ; k2= W_coef[ 2 ]
//	k3 = W_coef[ 3 ]; k4 = W_coef[ 4 ]
//	// do the single 2D gaussian fit for florescent spot aa
//	V_fitError = 0 ; 	V_chisq = 0
//	FuncFitMD/H="11111"/N /NTHR=0 /G /W =2 /Q gaus2dAllAtOnce W_coef  image[ xStart, xEnd ][ yStart, yEnd ]
//	if( V_fitError == 0 )   // if fitting was without problems
//		chiWave[ 2 ] = V_chisq
//	else
//		chiWave[ 2 ] = 100
//	endif
//	//
//	return chiWave
//	//
//end

//// dbl 2D gaussian fitting, by all at once method
//function dblGaus2dAllAtOnce( pw, yw, xw1, xw2 ) : FitFunc
//	WAVE pw, yw, xw1, xw2
// 	//pw[ 0 ] = z0
// 	//pw[ 1 ] = amp
// 	//pw[ 2 ] = x0
// 	//pw[ 3 ] = y0
//  	//pw[ 4 ] = xWidth
//  	//pw[ 5 ] = amp1
//  	//pw[ 6 ] = x1
//  	//pw[ 7 ] = y1
//  	//pw[ 8 ] = width1
// 	yw =  pw[0] + pw[1] * exp(- (( xw1 - pw[2] ) / pw[4] )^2 - (( xw2 - pw[3] ) / pw[4] )^2 ) + pw[5] * exp(- (( xw1 - pw[6] ) / pw[8] )^2 - (( xw2 - pw[7] ) / pw[8] )^2 )
// 	//
// end

//// check and erases overlapping particles
//function checkOverlapSpots( outW_pDetGauss, typeCheck, minDist, cropArea )
//	wave outW_pDetGauss
//	variable typeCheck, minDist, cropArea
//	//
//	variable aa = 0, bb = 0
//	variable aaDeleted = 0
//	variable distance = 0
//	variable index = 0
//	//
//	do
//		//
//		bb = aa + 1
//		do
//			aaDeleted = 0
//			distance =  sqrt( (outW_pDetGauss[ aa ][ 0 ] - outW_pDetGauss[ bb ][ 0 ])^2 + (outW_pDetGauss[ aa ][ 1 ] - outW_pDetGauss[ bb ][ 1 ])^2 )
//			//
//			if( outW_pDetGauss[aa][2] > outW_pDetGauss[bb][2]  )
//				index = aa
//			else
//				index = bb
//			endif
//			//
//			if( distance < outW_pDetGauss[ index ][ 2 ] * 4  )	// if particles are overlapping
//				if( typeCheck == 1 )	// dbl Gauss fit
//					// check wether these two putative fluorescent spots are better described by single or double Guassian
//					// output is a wave of 3 rows, [0] - chi^2 of dbl 2d gauss, [1] - single 2d Gauss for aa particle, [2] - single 2d Gauss for aa particle
//					wave chiWave = singleVsDbl_2DGauss( image, outW_pDetGauss, aa , bb, cropArea )
//					// locate the minimal chi ^ 2
//					wavestats/q chiWave
//					if( V_minLoc == 0 )	// chi lowest is particle aa and bb together, so do not delete any of them
//						bb += 1
//					else	
//						if( V_minLoc == 1 ) 	// chi lowest is particle aa, so delete bb
//							deletepoints/m=0 bb, 1, outW_pDetGauss
//							aaDeleted = 0
//						elseif( V_minLoc == 1 )				// chi lowest is particle bb, so delete aa
//							deletepoints/m=0 aa, 1, outW_pDetGauss
//							aaDeleted = 1
//							break		
//						endif
//					endif
//					//
//				elseif( typeCheck == 2 )	// amplitude check
//					if( outW_pDetGauss[aa][3] * abs( outW_pDetGauss[aa][2] ^ 2 ) > outW_pDetGauss[bb][3] * abs( outW_pDetGauss[bb][2] ^ 2 ) )
//						deletepoints/m=0 bb, 1, outW_pDetGauss
//						aaDeleted = 0
//					else
//						deletepoints/m=0 aa, 1, outW_pDetGauss
//						aaDeleted = 1
//						break
//					endif
//					//
//				endif
//				//
//			else					// particles are not overlapping
//				bb += 1
//			endif
//			//					// check if the counter is exceeeding limits of the table
//			if( bb >= dimsize( outW_pDetGauss, 0 ) )
//			 	break
//			 endif
//			 //
//		while(1)
//		//
//		if( aaDeleted == 0 )		// if aa particle was not deleted last iteration, then update aa
//			aa += 1
//		endif
//		//						// check if the counter is exceeeding limits of the table
//		if( aa >= dimsize(outW_pDetGauss,0) )
//			break
//		endif
//		//
//	while(1)
//	//
//end
