#pragma rtGlobals=1		// Use modern global access method.

//// optimization of normalization constants for few traces
//
//function optimizeConstants( inputWave , dx1, dx2 , wOutNorm , Bfactor , silentToggle )
//	wave inputWave, wOutNorm
//	variable dx1, dx2, Bfactor, silentToggle
//	//
//	variable gg = 50 , kk = 0							// counters
//	wavestats/q inputWave
//	variable photNorm = 1 / V_avg						// average level normalization constant	
//	variable durNorm = 0								// duration normalization constant
//	variable numNAnsMin = dimSize(inputWave, 0 ) - dx1- dx2 // num of Nans in PDF of ICP location should be less than this number
//	variable bfactor1 = 0	// ouput var
//	variable endValue = 300 - gg
//	//
//	make/o/d/n =1 wOut
//	//
//	do	
//		durNorm  = gg - kk
//		durNorm /= dimSize( inputWave , 0 )
//		//
//		bfactor1 = optimizeConstant( inputWave , durNorm, photNorm , dx1, dx2 , wOut )	// optimizing duration normalization constant
//		//
//		if( wOut[ 0 ] < numNAnsMin && bfactor1 > Bfactor )
//			//
//			wOutNorm[ 0 ] = durNorm	// duration
//			wOutNorm[ 1 ] = photNorm	// photons
//			//
//			break
//			//	
//		endif
//		//
//		kk += 50
//		if(kk >= endValue )
//			break
//		endif
//	while( kk < endValue)
//	//
//	if( silentToggle == 1 )
//		print "Optimization of normalization constants loop found these values of the constants: "+num2str( durNorm )+" duration; "+num2str( photNorm )+" avg level"
//	endif
//	//
//	killVAriables/z gg, kk, photNorm, durNorm, numNAnsMin
//	//
//	return bfactor1
//end
////*****************************************************************************************
//// 	optimize the normalization constant to give the maximum Bayesian factor
//Function/d optimizeConstant( waveInput1 , secondConstant , normCostant, dx1, dx2 , wOut  )
//	// inputs	
//	wave waveInput1, wOut
//	variable normCostant, secondConstant, dx1, dx2
//	// defining local variables
//	//
//	variable stopVar = 0, BFValue = 0
//	//
//	BFValue = locationICP_gaussDist_TA_MT(  waveInput1 , secondConstant , normCostant , 0 , 0  , dx1, dx2 )
//	BFValue = BF_calculation_gaussDist_TA_MT( waveInput1 , secondConstant , normCostant , 0 , dx1, dx2 )	
//	//
//	wavestats/q probICPLocation
//	wOut[ 0 ] = V_numNans
//	// if function is diverging
//	V_maxLoc = 0
//	wavestats/q probICPLocation
//	stopVar = V_maxLoc
//	//
//	wavestats/q /r = [ 0 , stopVAr ] probICPLocation
//	if( V_npnts == 0 )
//		BFValue = 0
//	endif
//	//
//	wavestats/q /r = [ stopVAr, dimSIze( probICPLocation, 0 ) ] probICPLocation
//	if( V_npnts == 0 )
//		BFValue = 0
//	endif
//	// release memory occupied by locals
//	killVariables/z stopVar
//	return BFValue
//end